#import <eoaccess/EOExpressionArray.h>
#import <eoaccess/EOSQLExpression.h>

@interface MiniSQLExpression:EOSQLExpression
- (NSString *)expressionValueForAttribute:(EOAttribute *)anAttribute;
    // Does the appropriate aliasing and name generation for an attribute in
    // the context of this particular query.

- (NSMutableDictionary *)relationshipPathsForAttributes:(NSArray *)attributes
    qualifier:(EOQualifier *)qualifier fetchOrder:(NSArray *)fetchOrder;
    // The keys in the returned dictionary represent paths to relationships
    // referenced by this expression and their associated objects are aliases
    // that can be used in the query language.

- fromClauseForRelationshipPaths:(NSDictionary *)relationships
    entity:(EOEntity *)entity;
    // Builds a SQL FROM clause using a dictionary of aliased relation paths

- whereClauseForQualifier:(EOQualifier *)qualifier
    joinExpresssion:joinExpression;
    // Builds an SQL WHERE clause using the qualifier and joinExpression

@end
