#import <foundation/NSObject.h>
#import <foundation/NSUtilities.h>

#import <appkit/Application.h>

@implementation NSObject (IB)

+ (BOOL)_canAlloc
{
  return YES;
}


- (BOOL)isKindOf:aClass
{
  return [self isKindOfClass:aClass];
}


- (BOOL)respondsTo:(SEL)aSel
{
  return [self respondsToSelector:aSel];
}


- perform:(SEL)aSelector
   with:anObject
{
  return [self perform:aSelector
           withObject:anObject];
}


- perform:(SEL)aSelector 
   with:anObject
   with:anotherObject
{
  return [self perform:aSelector 
           withObject:anObject
           withObject:anotherObject];
}

- (void)doesNotRecognizeSelector:(SEL)aSelector
{
	NSLog(@"%s does not respond to selector %s.",
		[[[self class] description] cString],
		sel_getName(aSelector));
	abort();
}
@end 
